#define _binary_payload		w9.gzdio
#define _source_payload		w9.gzdio

%global __requires_exclude ^perl\\((PDF::Reuse.*|Pedigree.*|TeXLive.*|Tk::path_tre|only|pdfTeX|script::MakeSPList)\\)|pear\\(animals.php\\)
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_docdir}

# instructions to build texlive with 'xindy' enabled:
#
# 1) bootstrap, with xindy disabled, by defining "enable_xindy" to 0 below.
# This this would build the package "texlive". Under these conditions build
# also the companion package texlive-texmf.
#
# 2) increase the release number in this spec file and enable xindy, by
# defining "enable_xindy" to 1 below, and using the newer texlive and
# texlive-texmf packages just built at previous step.
%define enable_xindy		1

# let asymptote be packaged separately, as the generated one is known
#   to not be fully functional
%define enable_asymptote	0

# in its own package
%define enable_xdvik            1
%define enable_dvi2tty          1

%define with_system_poppler	1
%define with_system_dialog	1
%define with_system_icu		1
%define with_system_lcdf	0
%define with_system_psutils	1
%define with_system_t1lib	1
%define with_system_tex4ht	0
%define with_system_teckit	0

%define enable_shared		1

%define texmfbindir		%{_bindir}
%define texmfdir		%{_datadir}/texmf
%define texmfdistdir		%{_datadir}/texmf-dist
%define texmflocaldir		%{_datadir}/texmf-local
%define texmfextradir		%{_datadir}/texmf-extra
%define texmffontsdir		%{_datadir}/texmf-fonts
%define texmfprojectdir		%{_datadir}/texmf-project
%define texmfvardir		%{_localstatedir}/lib/texmf
%define texmfconfdir		%{_sysconfdir}/texmf
%define relYear	2020


%define subrel 1
#-----------------------------------------------------------------------
Name:		texlive
Version:	%{relYear}0406
Release:	%mkrel 9
Summary:	The TeX formatting system
Group:		Publishing
License:	https://www.tug.org/texlive/LICENSE.TL
URL:		https://tug.org/texlive/
Source0:	ftp://tug.org/historic/systems/texlive/%{relYear}/%{name}-%{version}-source.tar.xz
Source1:	ftp://tug.org/historic/systems/texlive/%{relYear}/%{name}-%{version}-source.tar.xz.sha512

Provides:	tetex  = %{version}-%{release}
Provides:	context = %{version}-%{release}
Provides:	dvipdfm = %{version}-%{release}
Provides:	dvips = %{version}-%{release}
Provides:	mfwin = %{version}-%{release}
Provides:	usrlocal = %{version}-%{release}
%if %{enable_xdvik}
Obsoletes:	tetex-xdvi <= 3.1
Provides:	xdvi = %{version}-%{release}
Requires:	ghostscript-module-X
Obsoletes:	xdvi <= 22.86
Obsoletes:	xdvik <= 22.84.16
Obsoletes:	texlive-xdvi <= 2007
%rename xdvik
%endif
Provides:	afm = %{version}-%{release}
Provides:	dvilj = %{version}-%{release}
Provides:	dvipdfm = %{version}-%{release}
Provides:	tetex-dvips = %{version}-%{release}
Provides:	dviutils = %{version}-%{release}
Provides:	tetex-latex  = %{version}-%{release}
Provides:	latex = %{version}-%{release}

Obsoletes:	kpathsea <= 2007
Obsoletes:	pdfjam <= 1.21
Obsoletes:	tetex <= 3.1
Obsoletes:	tetex-context <= 3.1
Obsoletes:	tetex-devel <= 3.1
Obsoletes:	tetex-dvipdfm <= 3.1
Obsoletes:	tetex-dvips <= 3.1
Obsoletes:	tetex-dvips <= 3.1
Obsoletes:	tetex-dvilj <= 3.0
Obsoletes:	tetex-latex <= 3.1
Obsoletes:	tetex-mfwin <= 3.1
Obsoletes:	tetex-usrlocal <= 3.1
Obsoletes:	texlive-afm <= 2007
Obsoletes:	texlive-context <= 2007
Obsoletes:	texlive-dvilj <= 2007
Obsoletes:	texlive-dvipdfm <= 2007
Obsoletes:	texlive-dvips <= 2007
Obsoletes:	texlive-dviutils <= 2007
Obsoletes:	texlive-latex <= 2007
Obsoletes:	texlive-mfwin <= 2007
Obsoletes:	texlive-fonts <= 2007
Obsoletes:	texlive-mf2pt1 < 2.5.0-4
%rename abntex2

#-----------------------------------------------------------------------
%if %{with_system_dialog}
Requires:	cdialog
%endif
Requires:	ghostscript
%if %{enable_asymptote}
Requires:	gv
Requires:	tkinter
%endif
%if %{with_system_lcdf}
Requires:	lcdf-typetoools
%else
Provides:	lcdf-typetools = %{version}
Obsoletes:	lcdf-typetools <= 2.59-5
%endif
%if %{with_system_psutils}
Requires:	psutils
%endif
%if %{with_system_teckit}
Requires:	teckit
%endif
%if %{with_system_tex4ht}
Requires:	tex4ht
%else
Provides:	tex4ht = %{version}
Obsoletes:	tex4ht <= 1:1.0.2008_02_28_2058
%endif
Requires:	texlive-collection-basic

# Fix upgrade for luatex (mga#12303)
Requires(posttrans):       zlib >= 1.2.8
Requires(posttrans):       kpathsea >= %{version}

#-----------------------------------------------------------------------
BuildRequires:	autoconf-archive
BuildRequires:	bison
%if %{enable_xindy}
BuildRequires:	clisp
BuildRequires:	ffcall-devel
%endif
%if %{enable_asymptote}
BuildRequires:	fftw-devel
BuildRequires:	flex
%endif
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:  gmp-devel
%if %{enable_asymptote}
BuildRequires:	libgc-devel
BuildRequires:	libsigsegv-devel
BuildRequires:	ghostscript-dvipdf
BuildRequires:	gsl-devel
BuildRequires:	GL-devel
%endif
BuildRequires:	ghostscript-devel
BuildRequires:	pkgconfig(libbrotlienc)
BuildRequires:	pkgconfig(libwoff2enc)
BuildRequires:	xxhash-devel
BuildRequires:	potrace-devel
BuildRequires:	pkgconfig(gdlib)
BuildRequires:  graphite2-devel
BuildRequires:  pkgconfig(harfbuzz)
BuildRequires:  pkgconfig(mpfr)
%if %{with_system_poppler}
BuildRequires: pkgconfig(poppler)
%endif
BuildRequires:	pkgconfig(xaw7)
%if !%{with_system_dialog}
BuildRequires:	ncurses-devel
%endif
BuildRequires:	pkgconfig(libpng)
%if %{with_system_t1lib}
BuildRequires:	t1lib-devel
%endif
%if %{with_system_teckit}
BuildRequires:	teckit-devel
%endif
%if %{with_system_icu}
BuildRequires:	icu-devel
%endif
%if %{enable_xindy}
BuildRequires:	texlive >= 20200406
BuildRequires:	texlive-fonts-sources >= 20200406
BuildRequires:	texlive-dist >= 20200406
%endif
%if %{enable_asymptote}
BuildRequires:	texinfo
%endif
BuildRequires:	pkgconfig(zziplib)
BuildRequires:	pkgconfig(cairo)
BuildRequires:	libpaper-devel
BuildRequires:	mercurial

#-----------------------------------------------------------------------
Patch1: texlive-20160523-mageia-format.patch
%if %{enable_asymptote}
Patch2: texlive-20160523-mageia-asymptote.patch
%endif
Patch4: texlive-20160523-texmf-mageia-kpfix.patch
Patch5: includePatch.patch
Patch7: texlive-dvisvgm-system-libs.patch
Patch8: texlive-xindy-help-stdout.patch
# Poppler patches
Patch101: 0001-try-to-adapt-to-poppler-0.58.patch

#-----------------------------------------------------------------------
%description
TeX Live is an easy way to get up and running with the TeX document
production system. It provides a comprehensive TeX system. It includes
all the major TeX-related programs, macro packages, and fonts that are
free software, including support for many languages around the world.

%files
%{texmfbindir}/*
%dir %{texmfvardir}
%ghost %{texmfvardir}/ls-R
%dir %{texmfconfdir}
%ghost %{texmfconfdir}/ls-R
%ghost %config(noreplace) %{texmfconfdir}/web2c/updmap.cfg


#-----------------------------------------------------------------------
%if %{enable_shared}
########################################################################
%define        kpathsea_major          6
%define        kpathsea                %{mklibname kpathsea %{kpathsea_major}}

%package	-n %{kpathsea}
Summary:	Path searching library for TeX-related files
Group:		System/Libraries
Provides:	kpathsea = %{version}-%{release}

%description	-n %{kpathsea}
Kpathsea implements generic path searching, configuration,
and TeX-specific file searching.

%files		-n %{kpathsea}
%{_libdir}/libkpathsea.so.%{kpathsea_major}
%{_libdir}/libkpathsea.so.%{kpathsea_major}.*

#-----------------------------------------------------------------------
%define	kpathsea_devel		%{mklibname -d kpathsea}

%package	-n %{kpathsea_devel}
Summary:	Kpathsea development files
Group:		Development/C
Requires:	kpathsea = %{version}-%{release}
Provides:	kpathsea-devel = %{version}-%{release}

%description	-n %{kpathsea_devel}
Kpathsea implements generic path searching, configuration,
and TeX-specific file searching.
This package includes the kpathsea development files.

%files		-n %{kpathsea_devel}
%{_includedir}/kpathsea
%{_libdir}/libkpathsea.so
%{_libdir}/pkgconfig/kpathsea.pc

#-----------------------------------------------------------------------
%define        texlua_major           5
%define        texluajit_major        2
%define        texlua                 %{mklibname texlua %{texlua_major}}

%package	-n %{texlua}
Summary:	Library for TeXlua
Group:		System/Libraries
Provides:	texlua = %{version}-%{release}

%description	-n %{texlua}
TeXlua library

%files		-n %{texlua}
%{_libdir}/libtexlua53.so.%{texlua_major}
%{_libdir}/libtexlua53.so.%{texlua_major}.*
%{_libdir}/libtexluajit.so.%{texluajit_major}
%{_libdir}/libtexluajit.so.%{texluajit_major}.*


#-----------------------------------------------------------------------
%define	texlua_devel		%{mklibname -d texlua}

%package	-n %{texlua_devel}
Summary:	Library for TeXlua
Group:		Development/C
Requires:	texlua = %{version}-%{release}
Provides:	texlua-devel = %{version}-%{release}

%description	-n %{texlua_devel}
TeXlua library
This package includes the TeXlua development files.

%files		-n %{texlua_devel}
%{_includedir}/texlua53
%{_includedir}/texluajit
%{_libdir}/libtexlua53.so
%{_libdir}/pkgconfig/texlua53.pc
%{_libdir}/libtexluajit.so
%{_libdir}/pkgconfig/texluajit.pc

#-----------------------------------------------------------------------
%define        synctex_major           2
%define        synctex                 %{mklibname synctex %{synctex_major}}

%package	-n %{synctex}
Summary:	Library for SyncTeX
Group:		System/Libraries
Provides:	synctex = %{version}-%{release}

%description	-n %{synctex}
synctex library

%files		-n %{synctex}
%{_libdir}/libsynctex.so.%{synctex_major}
%{_libdir}/libsynctex.so.%{synctex_major}.*

#-----------------------------------------------------------------------
%define	synctex_devel		%{mklibname -d synctex}

%package	-n %{synctex_devel}
Summary:	Library for SyncTeX
Group:		Development/C
Requires:	synctex = %{version}-%{release}
Provides:	synctex-devel = %{version}-%{release}

%description	-n %{synctex_devel}
synctex library
This package includes the synctex development files.

%files		-n %{synctex_devel}
%{_includedir}/synctex
%{_libdir}/libsynctex.so
%{_libdir}/pkgconfig/synctex.pc

#-----------------------------------------------------------------------
%define        ptexenc_major           1
%define        ptexenc                 %{mklibname ptexenc %{ptexenc_major}}

%package	-n %{ptexenc}
Summary:	Library for Japanese pTeX
Group:		System/Libraries
Provides:	ptexenc = %{version}-%{release}

%description	-n %{ptexenc}
ptexenc is a useful library for Japanese pTeX
(which stands for publishing TeX, and is an extension of
TeX by ASCII Co.) and its surrounding tools.

%files		-n %{ptexenc}
%{_libdir}/libptexenc.so.%{ptexenc_major}
%{_libdir}/libptexenc.so.%{ptexenc_major}.*

#-----------------------------------------------------------------------
%define	ptexenc_devel		%{mklibname -d ptexenc}

%package	-n %{ptexenc_devel}
Summary:	Library for Japanese pTeX
Group:		Development/C
Requires:	ptexenc = %{version}-%{release}
Provides:	ptexenc-devel = %{version}-%{release}

%description	-n %{ptexenc_devel}
ptexenc is a useful library for Japanese pTeX
(which stands for publishing TeX, and is an extension of
TeX by ASCII Co.) and its surrounding tools.
This package includes the ptexenc development files.

%files		-n %{ptexenc_devel}
%{_includedir}/ptexenc
%{_libdir}/libptexenc.so
%{_libdir}/pkgconfig/ptexenc.pc

########################################################################
# enable_shared
%endif

#-----------------------------------------------------------------------
%prep
%autosetup -S hg -n %{name}-%{version}-source

# poppler
cp -pv texk/web2c/pdftexdir/pdftoepdf{-poppler0.86.0,}.cc
cp -pv texk/web2c/pdftexdir/pdftosrc{-poppler0.83.0,}.cc

# setup default builtin values, added to paths.h from texmf.cnf
perl -pi -e 's%^(TEXMFMAIN\s+= ).*%$1%{texmfdistdir}%;'			  \
	 -e 's%^(TEXMFDIST\s+= ).*%$1%{texmfdistdir}%;'			  \
	 -e 's%^(TEXMFLOCAL\s+= ).*%$1%{texmflocaldir}%;'			  \
	 -e 's%^(TEXMFSYSVAR\s+= ).*%$1%{texmfvardir}%;'		  \
	 -e 's%^(TEXMFSYSCONFIG\s+= ).*%$1%{texmfconfdir}%;'		  \
	 -e 's%^(TEXMFHOME\s+= ).*%$1\$HOME/texmf%;'			  \
	 -e 's%^(TEXMFVAR\s+= ).*%$1\$HOME/.texlive%{relYear}/texmf-var%;'	  \
	 -e 's%^(TEXMFCONFIG\s+= ).*%$1\$HOME/.texlive%{relYear}/texmf-config%;'\
	 -e 's%^(OSFONTDIR\s+= ).*%$1%{_datadir}/fonts%;'		  \
	texk/kpathsea/texmf.cnf

#-----------------------------------------------------------------------
%build
export CXXFLAGS="%{optflags} -std=c++14"

#for dvisvgm system libs patches
autoreconf -vfi texk/dvisvgm

mkdir -p Work
pushd Work

CONFIGURE_TOP=.. \
%configure							\
	--with-banner-add="/Mageia"				\
	--disable-native-texlive-build				\
	--enable-missing					\
	--disable-linked-scripts				\
	--with-system-gmp					\
	--with-system-graphite2					\
	--with-system-harfbuzz					\
	--with-system-libpaper					\
	--with-system-mpfr					\
	--with-system-zlib					\
%if %{enable_shared}
	--enable-shared						\
	--disable-static					\
%else
	--disable-shared					\
%endif
%if %{enable_xindy}
	--enable-xindy						\
	--enable-xindy-rules            			\
%else
	--disable-xindy						\
%endif
%if %{enable_xdvik}
        --enable-xdvik                                          \
%else
        --disable-xdvik                                         \
%endif
%if %{enable_dvi2tty}
        --enable-dvi2tty                                        \
%else
        --disable-dvi2tty                                       \
%endif
	--with-system-freetype2					\
	--with-freetype2-includes=%{_includedir}/freetype2	\
%if %{with_system_dialog}
	--disable-dialog					\
%else
	--enable-dialog						\
%endif
%if %{with_system_psutils}
	--disable-psutils					\
%else
	--enable-psutils					\
%endif
	--with-system-gd					\
%if %{with_system_lcdf}
	--disable-lcdf-typetools				\
%endif
	--with-system-libpng					\
%if %{with_system_t1lib}
	--with-system-t1lib					\
	--disable-t1utils					\
%endif
%if %{with_system_teckit}
	--disable-teckit					\
	--with-teckit-includes=%{_includedir}/teckit		\
%endif
%if %{with_system_tex4ht}
	--disable-tex4htk					\
%endif
%if %{with_system_icu}
	--with-system-icu					\
%else
	--without-system-icu					\
%endif
%if %{with_system_poppler}
	--with-system-xpdf					\
	--with-system-poppler					\
%else
	--without-system-xpdf					\
%endif
	--with-system-zziplib					\
	--with-system-cairo					\
	--with-system-pixman
%make_build

popd

%if %{enable_asymptote}
pushd utils/asymptote
%configure							\
	--enable-gc=system					\
	--enable-texlive-build					\
	--datadir=%{texmfdir}
%make_build
popd
%endif

#-----------------------------------------------------------------------
%install
pushd Work
%make_install
popd

%if %{enable_asymptote}
pushd utils/asymptote
%make_install
popd
%endif

mkdir -p %{buildroot}%{_datadir}
for dir in texmf texmf-dist; do
    if [ -d %{buildroot}%{_prefix}/$dir ]; then
	rm -fr %{buildroot}%{_datadir}/$dir
	mv %{buildroot}%{_prefix}/$dir %{buildroot}%{_datadir}
    fi
done

mkdir -p %{buildroot}%{texmfvardir}
mkdir -p %{buildroot}%{texmfconfdir}

%if %{with_system_lcdf}
# stray directory left
rm -fr %{buildroot}%{_datadir}/lcdf-typetools-for-tex-live
%else
# openmpi has a program with the same name
if [ -f %{buildroot}%{texmfbindir}/otfinfo ]; then
    mv -f %{buildroot}%{texmfbindir}/otfinfo{,-texlive}
fi
%endif

pushd %{buildroot}%{texmfbindir}
	# missing symbolic links
	ln -sf aleph lamed
	ln -sf luatex dvilualatex
	ln -sf luatex dviluatex
	ln -sf luahbtex lualatex
	ln -sf pdftex amstex
	ln -sf pdftex cslatex
	ln -sf pdftex csplain
	ln -sf pdftex eplain
	ln -sf pdftex etex
	ln -sf pdftex latex
	ln -sf pdftex mex
	ln -sf pdftex mltex
	ln -sf pdftex mllatex
	ln -sf pdftex pdfcslatex
	ln -sf pdftex pdfcsplain
	ln -sf pdftex pdfetex
	ln -sf pdftex pdflatex
	ln -sf pdftex pdfmex
	ln -sf pdftex physe
	ln -sf pdftex phyzzx
	ln -sf pdftex utf8mex
	ln -sf pdftex texsis
	ln -sf ptex platex
	ln -sf mpost metafun
	ln -sf mpost mfplain
	ln -sf xetex xelatex

    # correct symlinks
    for file in *; do
	link=`readlink $file` || :
	if [ "x$link" != "x" ]; then
	    ln -sf `echo $link |					\
		sed	-e 's|\.\./.*texmf-dist/|%{texmfdistdir}/|'	\
			-e 's|\.\./.*texmf/|%{texmfdir}/|'`		\
		$file
	fi
    done
%if %{with_system_dialog}
	ln -sf %{_bindir}/dialog tcdialog
%endif
%if %{enable_asymptote}
	ln -sf %{texmfdir}/asymptote/GUI/xasy.py xasy
%endif
	# install scripts from texlive-texmf
	rm -f a2ping afm2afm arlatex authorindex autoinst bibexport		\
	bundledoc cachepic cmap2enc de-macro dviasm ebong e2pall	\
	epspdf epspdftk epstopdf fig4latex findhyph font2afm		\
	fragmaster ht htcontext htlatex htmex httex httexi htxelatex	\
	htxetex latex2man latexdiff latexdiff-vc latexmk latexrevise	\
	listings-ext.sh makeglossaries mathspic mk4ht mkgrkindex	\
	mkjobtexmf mkluatexfontdb mkt1font mptopdf ot2kpx pdf180	\
	pdf270 pdf90 pdfannotextractor pdfatfi pdfbook pdfcrop	\
	pdfflip pdfjam pdfjam-pocketmod pdfjam-slides3up		\
	pdfjam-slides6up pdfjoin pdfnup pdfpun pdfthumb perltex	\
	pfm2kpx pkfix  pkfix-helper ppower4 ps4pdf pst2pdf purifyeps	\
	repstopdf rpdfcrop rungs showglyphs simpdftex splitindex	\
	svn-multi texcount texdiff texdirflatten texdoc texdoctk	\
	texloganalyser thumbpdf tlmgr ulqda updmap vpe vpl2ovp	\
	vpl2vpl
popd

# use texmf data
rm -fr %{buildroot}%{texmfdir} %{buildroot}%{texmfdistdir}

# install manual pages and info files from texlive-texmf tarball
rm -fr %{buildroot}%{_mandir} %{buildroot}%{_infodir}

%if !%{enable_shared}
# do not generate dynamic libraries and do not install static ones
rm -fr %{buildroot}%{_libdir}
rm -fr %{buildroot}%{_includedir}
%endif

rm -f %{buildroot}%{_datadir}/applications/xdvi.desktop

# drop .la files
find %{buildroot} -name "*.la" -delete

#-----------------------------------------------------------------------
%transfiletriggerin -P 20 -- %{texmfdir} %{texmfdistdir} %{texmflocaldir} %{texmffontsdir} 
export TEXMF=/usr/share/texmf-dist
export TEXMFCNF=/usr/share/texmf-dist/web2c
export TEXMFCACHE=/var/lib/texmf
%{_bindir}/texhash > /dev/null 2>&1
%{_bindir}/updmap-sys --syncwithtrees --force > /dev/null 2>&1
%{_bindir}/fmtutil-sys --no-strict --all > /dev/null 2>&1
